; OKFILE6 is the read any routines
;
;
INCLUDE     c:\ok\okfiles.asm
dseg        SEGMENT PUBLIC 'DATA'
            ASSUME CS:cseg,DS:dseg,ES:dseg
;
extrn   try_header:word,handle:word,file_off:word
extrn  read_prog:word
;
;
dseg        ENDS
cseg        SEGMENT PUBLIC 'CODE'
            ASSUME CS:cseg,DS:dseg,ES:dseg
EXTRN       reset_segs:NEAR
;
;
TRY_IN      PROC    NEAR
public try_in
       call  reset_segs
       call  reset_file
; the first three bytes are in TRY_HEADER.TRY_SIG
; check for MSP should be Dan
       cmp   try_HEADER.try_sig,'D'
       jne   try_gif
       cmp   word ptr try_HEADER.try_sig+1,'na'
       jne   try_gif
       mov   file_off,2*15
       jmp   reread_head
try_gif:
       cmp   try_HEADER.try_sig,'G'
       jne   try_tif
       cmp   word ptr try_HEADER.try_sig+1,'FI'
       jne   try_tif
       mov   file_off,31*15
       jmp   reread_head
try_tif:
       cmp   try_HEADER.try_sig,49h
       jne   try_PCB
       cmp   word ptr try_HEADER.try_sig+1,2a49h
       jne   try_PCB
       mov   file_off,17*15
       jmp   reread_head
try_PCB:
       cmp   try_HEADER.try_sig,0ah
       jne   try_gem
       cmp   word ptr try_HEADER.try_sig+1,0102h
       jne   try_gem
       mov   file_off,13*15
       jmp   reread_head
try_gem:
; check gem file
       cmp   try_HEADER.try_sig,0
       jne   try_mac
       cmp   word ptr try_HEADER.try_sig+1,0001h
       jne   try_mac
       mov   file_off,19*15
       jmp   reread_head
try_mac:
       mov   file_off,11*15
       jmp   reread_head
TRY_READ:
public try_read ; never actually used
     stc
     ret
;
reset_file:
       mov   ax,4200h
       mov   bx,handle
       mov   cx,0
       mov  dx,0
       int   21h
     ret
reread_head:
extrn file_type:byte
           lea     di,cs:file_type
           add     di,file_off
           MOV     SI,cs:[DI.HEADER]      ;GET LOCATION OF HEADER INFO
           MOV     CX,[SI]             ;GET NUMBER OF BYTES IN HEADER
           CMP     CX,0
           JE      decomp_eof
           MOV     DX,SI               ;
           ADD     DX,2                ;GET PAST BYTES IN HEADER
extrn read_file:near
           call    read_file                   ;READ HEADER
           jnc     decomp_eof
           stc
           ret
decomp_eof:
           clc
           MOV     BX,cs:[DI.DISK_IN]         ;GET DISK INPUT PROGRAM
           MOV     read_PROG,BX
           push    ds
           push    es
           call    reset_segs
           clc
           call    cs:[DI.INPUT]
           pop     es
           pop     ds
           JNC     good_header
           stc
good_header:
      ret
TRY_IN     ENDP
cseg        ENDS
            END
;
