; OKFILE14.ASM has tcomplete fax reads
;
;
;
include f:\ok\okfiles.asm
;
dseg segment public 'DATA'
     ASSUME  CS:CSEG,DS:DSEG,ES:DSEG
extrn   vint:word,vphase:word,buffer:word
     ASSUME  CS:CSEG,DS:DSEG,ES:DSEG
     EXTRN   CFX_HEADER:WORD
     EXTRN   PEL_SIZE:WORD
     EXTRN   WIDTH_PIX:WORD
     EXTRN   HEIGHT_PIX:WORD
     EXTRN   WIDTH_BYTES:WORD
;
;
;
dseg  ends
buffersize  equ 4000h
;
CSEG     SEGMENT PUBLIC 'CODE'
     ASSUME  CS:CSEG,DS:DSEG,ES:DSEG
EXTRN   WRITE_RAW:NEAR,reset_segs:near,write_file:near
EXTRN   READ_RAW:NEAR,calc_file_size:near
extrn   read_file:near,write_file:near,next_wait:near
extrn   flush_buffer:near,fill_buffer:near
extrn  decomp:word,move_raw:word
;
;
;
cfx_line:
;
; this reads each line of the image until five nuls are received
; bx has the count in a line
    mov   dl,1     ; start with white run
    mov   dh,0     ; number of bits in current byte
    mov   ax,buffer
    mov   ds,ax
    mov   es,ax
     cld
   mov   ah,0      ; fractional bits
cfx_loop0:
     cmp   bx,0
     jge   cfx_loop1
    call  reset_segs
     clc
     ret
cfx_loop1:
     lodsb
    cmp   al,7dh  ; nul token ?
    je    cfx_loop1
     cmp    al,69h
     je     got_eol
     jmp    not_eol
got_eol:
     cmp    word ptr ds:[si],6969h
     jne    eol_1
     cmp    word ptr ds:[si+2],6969h
     jne   eol_1
     mov   cx,bx
     cmp   cx,0
     jbe   by_eol_e
     mov   al,0ffh
     cld
rep  stosb
by_eol_e:
    call  reset_segs
     stc
     ret
eol_1:
; we have an eol, have to start the next line, fill out any of
; the current line thats not yet done
; bx has remaining bytes of line
     cmp   dh,0
     je    eol_1a
     mov   cx,8
     sub   cl,dh
     shl   ah,cl
     mov   byte ptr es:[di],ah
     inc   di
eol_1a:
     mov   cx,bx
     cmp   cx,0
     jbe   by_eol_1
     mov   al,0ffh
     cld
rep  stosb
by_eol_1:
    call  reset_segs
     clc
     ret
not_eol:
; here we have a code
    cmp   al,7fh  ; white line
    je    eol_1   ; not followed by an eol
    cmp   al,01
    jne   not_nul
    xor   dl,1
    jmp   cfx_loop0
not_nul:
    cmp   al,0
    jge   got_run
; process a single byte
    shl   al,1  ; get rid of high bit
; this shifts the bytes into ah
    mov   cx,7
    call  store_cfx_bits
    mov   dl,ah
    and   dl,1     ; color bit from last color
    jmp   cfx_loop0
got_run:
    cmp   al,65
    jl    not_exp
    mov   cl,al
    mov   ch,0
    sub   cx,64
    push  ax
    push  dx
    mov   ax,64
    mul   cx
    mov   cx,ax
    pop   dx
    pop   ax
    mov   al,0ffh
    cmp   dl,1
    je    gr_1
    mov   al,0
gr_1:
    call  store_cfx_bits
    jmp   cfx_loop0
not_exp:
; this is a non exponent run 1-64
    mov   cl,al
    mov   ch,0
    dec   cx
    mov   al,0ffh
    cmp   dl,1
    je    gr_2
    mov   al,0
gr_2:
    call  store_cfx_bits
    xor   dl,1  ; change color
    jmp   cfx_loop0
;



store_cfx_bits:
    shl   ax,1
    or    al,dl
    inc   dh
    cmp   dh,8
    jl    by_s_store
    mov   dh,0
    mov   byte ptr es:[di],ah
    dec   bx
    inc   di
by_s_store:
    loop  store_cfx_bits
    ret

CFX_READ:
public cfx_read
     stc
     ret
;
;
;
     PUBLIC  CFX_IN
CFX_IN:
     call    reset_segs
     cmp     word ptr CFX_HEADER.CFX_ID,0180h
     jne     bad_cfx
     cmp     byte ptr CFX_HEADER.CFX_ID+2,40h
     jne     bad_cfx
     jmp     good_cfx
bad_cfx:
     stc
     ret
good_cfx:
     lea     ax,cfx_line
     mov     cs:decomp,ax
     mov     height_pix,3000
     mov     ax,216
     cmp     cfx_header.cfx_type,0
     jne     not_scanner
     mov     ax,cfx_header.cfx_wid
not_scanner:
     MOV     WIDTH_BYTES,AX     ;SAVE AS BYTES
     SHL     AX,1
     SHL     AX,1
     SHL     AX,1
     MOV     WIDTH_PIX,AX     ;SAVE AS PIXELS
     CLC
     RET

;
;     IMAGE OUT
;
     PUBLIC  CFX_OUT
CFX_OUT:
     call    reset_segs
     call    calc_file_size
;    mov    cx,img_headero
;    lea    dx,img_headero+2
;    call   write_file
     RET




;
;     IMAGE WRITE
;
     PUBLIC  CFX_WRITE
CFX_WRITE:

;    call    reset_segs
;    mov    vint,0
;    CALL    WRITE_RAW
     RET





CSEG     ENDS
     END
