print macro string
      mov   curx,32
      mov   cury,64
      mov   left_margin,32
      call  blop
      lea   dx,string
      call  print_string
      endm
; OKFILE5 is another group of file reads
;
; this has sfp reads and gif reads and prt reads
;
;
INCLUDE     f:\ok\okfiles.asm
buffersize  EQU   4000h
lzbuffer    equ   4000h
dseg        SEGMENT PUBLIC 'DATA'
            ASSUME CS:cseg,DS:dseg,ES:dseg
;
EXTRN       buffer:WORD,width_bytes:WORD,height_pix:WORD
EXTRN       rle_header:BYTE,pcr_header:BYTE
extrn   crc_val:word,width_pix:word
extrn       curx:word,cury:word,left_margin:word,plane_switch:byte
extrn    srow:word,lrow:word,scol:word,lcol:word,planes:word
EXTRN   vint:word,vphase:word,color_map:byte
extrn  gif_header:word,sfp_header:word,vwid:word
extrn   tx:word,ty:word,scol:word,rcol:word,srow:word,rrow:word
extrn   fx:word,handle:word,spoint:word,hash_segment:word
;
; new variable to say if stuff gets xored to screen or overlayed
xor_read    db   0
public xor_read
; local only stuff used by the programs
pass        DW    0
in_buffer   DW    0
BUFFCOUNT   DW    0
sfp_letter db 0

font_descriptor equ this byte ; the esc,)s#W data for 26 goes here
fdcount   dw  26  ; count of how many bytes in descriptor head
          db  0
fonttype  db  0 ;0 = 7 bit, 1 = 8 bit
          dw  0
baseline  dw  0 ; offset from top of character cell to baseline
cellwidth dw  0 ; character cell width
cellhght  dw  0 ; character cell height
orient    db  0 ; 0 = portrait, 1 = landscape
fix_prop  db  0 ; fixed or proportional
sym_set   dw  0 ; symbol set
pitch     dw  0 ; default hmi ( space size )/4
height    dw  0 ; height of font*4
          db  0,0,0
style     db  0
strokew   db  0
typface   db  0
fontsize  dw  0
fontwidth dw  0
fontlen   dw  0
fontorig  dw  0
font1h    dw  0
font1m    dw  0
lett_loc  dw  0
chars     dw  0
letter    dw  0
fontbytes dw  0
dchar  equ this byte
          dd  0
          dw  0 ; orientation again
left_off  dw  0 ; left offset (space before character begins)
top_off   dw  0 ; distance from baseline to top of character
char_wid  dw  0 ; first dot to last horizontally
char_hght dw  0 ; top dot to bot dot
delta_x   dw  0 ; horizontal motion for this/4 (includes left_off)
save_si   dw  0
startsi   dw  0
save_di   dw  0
save_bp   dw  0
buffer_read db 0
last_pitch dw 0
off_bits  dw  0  ; amount to shift to right
width_byteso dw 0
public width_byteso
;
; GIF local data
;
gif_planes db 1  ; number of gif planes
gif_map_size dw 8 ; size of gif map
gif_resolution db 0 ; don't knwo why I need this, but keep it
;
gif_descriptor db ','
       dd 0
gif_width dw 0
gif_height dw 0
gif_desc2 db 0
;
 dd 0
;
cur_byte db  0,0
cur_word equ word ptr cur_byte
extra_byte db 0
cur_bits dw  0
readmask  dw  0
bitmask  dw  0
codesize dw  0
initcodesize dw 0
clear    dw  0
clearcode dw 0
firstfree dw 0
freecode  dw 0
eofcode   dw 0
maxcode   dw 0
;
;   this junk is from the nlzw code, I don't think it will fit
;
;
bitoffset     dw 0
bitoffset2    dw 0
yc            dw 0
oldcolor      db 0
yoffset       dw 0
xoffset       dw 0
curcode       dw 0
incode        dw 0
oldcode       dw 0
finchar       db 0
rasterseg     dw 0
rasterofs     dw 0
prefix equ 10000  ; start of prefix in hash
suffix equ 4000     ; start of suffix area
outcode equ 0   ; start in hash_seg
;canline db 640 dup (0)
code_count dw 0 ; keeps track of blocks
;   Masks: Array [0..9] of Integer = (7,15,$1f,$3f,$7f,$ff,$1ff,$3ff,$7ff,$fff);
masks  dw 7,15,1fh,3fh,7fh,0ffh,1ffh,3ffh,7ffh,0fffh
;   MaxCodes: Array [0..9] of Word = (4,8,16,$20,$40,$80,$100,$200,$400,$800);
maxcodes dw 4,8,16,20h,40h,80h,100h,200h,400h,800h
codemask  dw 1,3,7,15,15,15,15,15,15,15
out_bytes  dw 0
out_bits   dw 0
outcount   dw 0
out_total  dw 0
ten_lines  db 0
clean      db 0
;
;
;
dseg    ENDS
cseg        SEGMENT PUBLIC 'CODE'
            ASSUME CS:cseg,DS:dseg,ES:dseg
EXTRN  reset_segs:NEAR,read_file:NEAR,print_string:near
extrn  blop:near,flush_buffer:near
extrn  next_wait:near,fill_buffer:near,write_file:near
extrn  getkey:near,xor_check:near,present:near
extrn  do_sfpt:near,cc_setup:near
public gif_in,sfp_in
;
clean_buffer:
     push  ds
     push  es
     call  reset_segs
     mov  es,buffer
     mov  cl,gif_planes
     mov  ch,0
     mov  al,0
     mov  di,0
     cld
clean_buff:
     push  cx
     mov   cx,width_bytes
rep   stosb
     pop   cx
     loop  clean_buff
     pop   es
     pop   ds
     ret
;
;
;
;
;
;
GIF_READ PROC NEAR

public gif_read
       call   reset_segs
; the masm code did not work. Translate the pascal code
;
;   setup some variables
; reinitialization
;

;{Compute decompressor constant values, based on the code size}

;     ClearCode:=PowersOf2 [Codesize];
    mov  cx,codesize
    mov  ax,1
    shl  ax,cl
    mov  clearcode,ax
    cmp  ax,256
    jle   ok_codesize
    mov  ax,256
    mov  clearcode,ax
ok_codesize:
;     EOFCode:=ClearCode+1;
    inc  ax
    mov  eofcode,ax
;     FirstFree:=ClearCode+2;
    inc  ax
;     FreeCode:=FirstFree;
    mov  firstfree,ax
    mov  freecode,ax

;{The GIF spec has it that the code size is the code size used to compute the
;above values is the code size given in the file, but the code size used in
;compression/decompression is the code size given in the file plus one.}

;     Codesize:=Succ (Codesize);
      inc  codesize
;     InitCodeSize:=Codesize;
      mov   bx,codesize
      mov   initcodesize,bx
;     Maxcode:=Maxcodes [Codesize-2];
      dec   bx
      dec   bx
      shl   bx,1
      mov   ax,maxcodes[bx]
      mov   maxcode,ax
;     ReadMask:=Masks [Codesize-3];
      mov  cx,codesize
      mov  bx,1
      shl  bx,cl
      dec  bx
      mov  readmask,bx


;{Get ready to do the actual read/display. Free up the heap used by the
;GIF array since we don't need it any more, and if the user wants to save,
;reclaim it for the Picture array}

;
;  asm starts here, look at the gif asm stuff, compared to ours
;
;     OutCount:=0;
      mov outcount,0
;
; some things of my own
     mov out_bytes,0
     mov out_bits,0
     mov out_total,0
     call  clean_buffer
; set up the BP and SI registers and the segments
       mov  si,save_si
       mov  bp,save_bp
       mov  es,hash_segment
;
;{Decompress the file, continuing until you see the GIF EOF code. One
;obvious enhancement is to add checking for corrupt files here.}
;
;   Repeat
top:
;
;     {Get the next code from the raster array}
;
;          ReadCode;
           call  readcode
           jc    is_done
;
;          If Code <> EOFCode then
;          Begin
;
           cmp   ax,eofcode
           jne   not_end
is_done:
           jmp   finished
not_end:
;     {Clear code sets everything back to its initial value, then reads
;      the immediately subsequent code as uncompressed data.}
;
;            If Code = ClearCode then
             cmp  ax,clearcode
             je   do_clearcode
             jmp  by_clearcode
is_done2:
         jmp  finished
do_clearcode:
;               Begin
;                 DoClear;
          call  doclear
;                 ReadCode;
          call  readcode
          jc    is_done2
;                 CurCode:=Code;
          mov   curcode,ax
;                 OldCode:=Code;
          mov   oldcode,ax
;                 FinChar:=Code and BitMask;
          mov   clean,1
          jmp   by_raw   ; as per asm version
;  this is the old pascal stuff
          and   ax,bitmask
          mov   finchar,al
;                 AddToPixel (FinChar);
          call  addtopixel
;
;
;               End
          jmp   bottom
by_clearcode:
;               Else
;
;     {If not a clear code, then must be data: save same as CurCode and InCode}
;
;               Begin
;                CurCode:=Code;
;                InCode:=Code;
          mov   curcode,ax
          mov   incode,ax
;
;     {If greater or equal to FreeCode, not in the hash table yet; repeat
;      the last character decoded}
;
;                If Code>=FreeCode then
         cmp   ax,freecode
         jl    by_free
;                  Begin
;                    CurCode:=OldCode;
         mov   ax,oldcode
         mov   curcode,ax
;                    OutCode [OutCount]:=FinChar;
         mov   bx,outcount
         mov   al,finchar
      mov  al,es:[bx+outcode]
;                    OutCount:=Succ (OutCount);
         inc  outcount
;                  End;
by_free:
;
;     {Unless this code is raw data, pursue the chain pointed to by CurCode
;     through the hash table to its end; each code in the chain puts its
;     associated output code on the output queue.}
;
;                If CurCode>BitMask then
      mov   ax,curcode
      cmp   ax,bitmask
      jle   by_raw
;                   Repeat
;                     OutCode [OutCount]:=Suffix [CurCode];
loopbr:
      mov  bx,curcode
      mov  al,es:[bx+suffix]
      mov  bx,outcount
      mov  es:[bx+outcode],al
;                     OutCount:=Succ (OutCount);
      inc  outcount
;                     CurCode:=Prefix [CurCode];
      mov  bx,curcode
      shl  bx,1
      mov  ax,es:[bx+prefix]
      mov  curcode,ax
;                   Until CurCode<=BitMask;
      cmp   ax,bitmask
      jg    loopbr
by_raw:  ; known as done in asm version
;
;      {The last code in the chain is treated as raw data.}
;
;               FinChar:=CurCode and BitMask;
        mov  ax,curcode
        and  ax,bitmask
        mov  finchar,al
;               OutCode [OutCount]:=FinChar;
        mov  bx,outcount
        mov  es:[outcode+bx],al
;               OutCount:=Succ (OutCount);
        inc   outcount
;
;     {Now we put the data out to the using routine. It's been stacked
;      LIFO, so deal with it that way}
;
;               For I:=OutCount-1 downto 0 do
       mov   cx,outcount
ap_loop:
       push  cx
       mov   bx,cx
       dec   bx
;                    AddToPixel (Outcode [I]);
       mov   al,es:[bx+outcode]
       call  addtopixel
       pop   cx
       loop  ap_loop
;
;      {Make darned sure OutCount gets set back to start}
;
;               OutCount:=0;
       mov  outcount,0
       cmp clean,0
       je  goon
       mov clean,0
       jmp  top
goon:
;
;      {Build the hash table on-the-fly. No table is stored in the file.}
;
;               Prefix [FreeCode]:=OldCode;
       mov   bx,freecode
       mov   ax,oldcode
       shl   bx,1
       mov   es:[bx+prefix],ax
;               Suffix [FreeCode]:=FinChar;
       mov   al,finchar
       mov   bx,freecode
       mov   es:[bx+suffix],al
;               OldCode:=InCode;
       mov   ax,incode
       mov   oldcode,ax
;
;     {Point to the next slot in the table. If we exceed the current MaxCode
;      value, increment the code size unless it's already 12. If it is, do
;      nothing: the next code decompressed better be CLEAR}
;
;               FreeCode:=Succ (FreeCode);
       inc  freecode
;               If FreeCode>=MaxCode then
       mov  ax,maxcode
       cmp  ax,0         ; could be negative, freecode can't be
       jl   by_slot
       cmp  freecode,ax
       jl   by_slot
;                Begin
;                  If CodeSize < 12 then
       cmp   codesize,12
       jge   by_slot
;                  Begin
;                     CodeSize:=Succ (CodeSize);
      inc  codesize
;                     MaxCode:=MaxCode*2;
      mov  cx,2
      mov  ax,maxcode
      mul  cx
      mov  maxcode,ax
;                     ReadMask:=Masks [CodeSize-3];
      mov  cx,codesize
      mov  bx,1
      shl  bx,cl
      dec  bx
      mov  readmask,bx
;                  End;
by_slot:
;                End;
;               End {not Clear};
bottom:
       jmp   top
finished:
       stc
       ret
;
GIF_READ endp
;
addtopixel:
; this puts the value in al to the output buffer
       push  si
       push  bp
       mov   es,buffer
       mov   di,out_bytes
       mov   cx,out_bits
       mov   dx,width_bytes
       mov   bp,width_pix
       mov   bx,80h
       shr   bx,cl
       mov   cl,gif_planes
       mov   ch,0
atp_loop:
       test  al,1
       jz    no_bit_out
       or    byte ptr es:[di],bl
no_bit_out:
       shr   al,1
       add   di,dx
       loop  atp_loop
;
       inc   out_bits
       inc   out_total
       cmp   out_bits,8
       jl    check_new_line
       inc   out_bytes
       mov   out_bits,0
check_new_line:
       cmp   out_total,bp
       jge   new_line
       jmp   ok_out_bits
new_line:
; buff out a line
       mov   ax,width_bytes
       mov   cl,gif_planes
       mov   ch,0
       mul   cx
       mov   cx,ax
       mov   out_bytes,0
       mov   out_total,0
       mov   out_bits,0
       mov   dx,0
       mov   di,0
       mov   si,0
       call  flush_buffer
       call  reset_segs
       inc   ten_lines
       cmp   ten_lines,10
       jl    no_10
       call  next_wait
       call  reset_segs
       mov   ten_lines,0
no_10:
       call  clean_buffer
ok_out_bits:
       mov   es,hash_segment
       pop   bp
       pop   si
       ret

bad_readcode2:
     jmp   bad_readcode
;
readcode:
; try again
       cld
       mov  al,cur_byte
       mov  ah,cur_byte+1
       push  ax
       mov  cx,codesize
       cmp  cx,8
       jl   cs_lt_8
       mov  al,cur_byte+1
       mov  cur_byte,al
       mov  al,extra_byte
       mov  cur_byte+1,al
       call  get_a_bytec
       jc   bad_readcode
       mov  ah,al
       mov  al,0
       mov  cx,24
       sub  cx,cur_bits
       cmp  cx,0
       je   by_shift1
       shr  ax,cl
by_shift1:
       mov  extra_byte,ah
       or   cur_byte+1,al
;
       mov   cx,codesize
       sub   cx,8
cs_lt_8:
       cmp   cx,0
       je    done_readcode
       shr   cur_word,cl
       mov   ah,extra_byte
       mov   al,0
       shr  ax,cl
       mov  extra_byte,ah
       or   cur_byte+1,al
       sub  cur_bits,cx
       cmp  cur_bits,16
       jg   done_readcode
; have to make up a byte
       cmp  cur_bits,16
       je   quick_byte
       call get_a_bytec
       jc   bad_readcode
       mov  ah,al
       mov  al,0
       mov  cx,16
       sub  cx,cur_bits
       shr  ax,cl
       mov  extra_byte,ah
       or   cur_byte+1,al
       add  cur_bits,8
       jmp  done_readcode
bad_readcode:
       pop   ax
       and   ax,readmask
       stc
       ret
quick_byte:
       call  get_a_bytec
       jc   bad_readcode
       mov   extra_byte,al
       add  cur_bits,8
done_readcode:
;
       pop   ax
       and   ax,readmask
       clc
       ret
;
;
;
get_a_bytec:  ; deblocks as it gets bytes
       call  get_a_byte2
       jc    e_gb
       dec   code_count
       cmp   code_count,0
       jg    ok_cc
       mov   ah,0
       cmp   ax,0
       je    e_gb
       mov   code_count,ax
       call  get_a_byte2
       jc    e_gb
ok_cc:
       clc
       ret
e_gb:
       stc
       ret

get_a_byte2:
; reads a byte for guys who used it in fp
;
    push  ds
    cmp   si,bp
    jl    ok_gb2
    mov  buffer_read,1
    push  ds
    push  es
    mov   ds,buffer
    mov     dx,4000h
    mov     cx,3fffh
    call    read_file
    pop    es
    pop    ds
    mov     bp,ax
    add     bp,4000h
    mov     si,4000h
    cmp     ax,0
    jne     ok_gb2
    pop  ds
    stc
    ret
ok_gb2:
    mov   ds,buffer
    cld
    lodsb
    pop  ds
    clc
    ret

doclear:
; this resets things to their initial state
;Procedure DoClear;
;
;    Begin
;      CodeSize:=InitCodeSize;
    mov    bx,initcodesize
    mov    codesize,bx
;      MaxCode:=MaxCodes [CodeSize-2];
    dec   bx
    dec   bx
    shl   bx,1
    mov   ax,maxcodes[bx]
    mov   maxcode,ax
;      FreeCode:=FirstFree;
       mov    ax,firstfree
       mov    freecode,ax
;      ReadMask:=Masks [CodeSize-3];
      mov  cx,codesize
      mov  bx,1
      shl  bx,cl
      dec  bx
      mov  readmask,bx
      ret
;    End;
;
    ret
;
;
;GIF Compuserve Graphics Interchange Format
;
;GIF struc
;GIF_count      dw      13
;GIF_SIG        db      'GIF'
;GIF_VER        db      '87a'
; screen descriptor
;GIF_screen_width   dw 640
;GIF_screen_length  dw 200
;GIF_DESC       db      00000000b ; broken down
;GIF_back       db      0    ;background color
;          db      0    ;un used
;GIF ends
GIF_IN       PROC    NEAR
     call reset_segs
       cmp   word ptr gif_header.gif_sig,"IG"
       jne    bad_gif
       cmp   gif_header.gif_sig+2,"F"
       je    good_gif
bad_gif:
       stc
       ret
good_gif:
; gif sig ok
       mov   al,gif_header.gif_desc ; color info
; get size of color map
       mov  ah,al
       and  ah,7  ; last 3 bits
       inc  ah
       mov  gif_planes,ah ; number of bits per pixel
       mov  bx,1
       mov  cl,ah
       shl  bx,cl
       mov  gif_map_size,bx  ; size of gif color map
       dec  bx
       mov  bitmask,bx
;
; now the color resolution stuff
;
;      mov  cl,4
;      shr  al,cl
;      and  al,7
;      inc  al
;      mov  gif_resolution,al
; time to prime the pump by filling up an incoming buffer
;
      push    ds
      push    es
      call  reset_segs
      mov     ax,buffer
      mov     dx,4000h
      mov     es,ax
      mov     ds,ax
      mov     cx,3fffh
      call    read_file
      cmp     ax,0
      pop     es
      pop     ds
      jg      good_gif_read
bad_gif_in:
      stc
      ret
good_gif_read:
      mov     si,4000h
      mov     bp,ax   ; amount in buffer
      add     bp,4000h ; place in buffer
;
; now get the global color map if present
       test  gif_header.gif_desc,80h   ; is the global map here?
       jz  no_global_map
; have to loop through the global map
       mov  cx,gif_map_size  ; actually three values here
       cmp  cx,0
       jle  no_global_map
       mov  dx,cx
       cmp  cx,16
       jle  ok_global_size
       mov  cx,16
ok_global_size:
       push  dx
       push  cx
       call  get_color_map
; color_map is set up
       pop   cx
       pop   dx
       jc   bad_gif_in
; check and see if the map was completed
       cmp   cx,dx
       je    no_global_map  ; ok they were the same size
       sub   dx,cx
       cmp   dx,0
       jle   no_global_map
; get the rest of the global map
       mov   cx,dx
get_rest_map:
       call   get_a_byte
       jc   bad_gif_in2
       call   get_a_byte
       jc   bad_gif_in2
       call   get_a_byte
       jc   bad_gif_in2
       loop   get_rest_map
       jmp   no_global_map
bad_gif_in2:
        jmp   bad_gif_in
no_global_map:
;
; now go for the the picture header
;
       call  reset_segs
       lea   di,gif_descriptor
       mov   cx,10
       cld
gif_des_loop:
       push di
       call get_a_byte
       pop  di
       jc   bad_gif_in2
       stosb
       loop  gif_des_loop
       cmp   gif_descriptor,','
       jne   bad_gif_in2
       mov  ax,gif_width
       mov  width_pix,ax
       add    ax,7
       shr   ax,1
       shr   ax,1
       shr   ax,1
       MOV     WIDTH_BYTES,AX      ;SAVE AS bytes
       cmp   gif_planes,1
       jle   no_g_planes
       cmp   plane_switch,1
       jle  no_g_planes
       mov    cl,plane_switch
       mov    ch,0
       mov    planes,cx
;      mul    cx
no_g_planes:
       mov  ax,gif_height
       mov   cl,gif_planes
       mov  ch,0
       mul   cx
       mov   height_pix,ax
;      test  gif_desc2,80h
       jmp   no_desc_map
; have a new color map
       mov   al,gif_desc2
       and  al,7  ; last 3 bits
       inc  al
       mov  gif_planes,al ; number of bits per pixel
       push  ax
       mov   ah,0
       mov   cx,ax
       mov  ax,gif_height
       mul   cx
       mov   height_pix,ax
       pop   ax
       mov  bx,1
       mov  cl,al
       shl  bx,cl
       mov  gif_map_size,bx  ; size of gif color map
       mov  cx,bx       ; actually three values here
       cmp  cx,0
       jle  bad_gif_in3
       cmp  cx,16
       jle  ok_global_size2
       mov  dx,cx
       mov  cx,16
       jmp  ok_global_size2
ok_global_size2:
       push  cx
       push  dx
       call  get_color_map
       pop   dx
       pop   cx
       jc   bad_gif_in3
       cmp   cx,dx
       je    no_desc_map ; ok they were the same size
       sub   dx,cx
       cmp   dx,0
       jle   no_desc_map
; get the rest of the global map
       mov   cx,dx
get_rest_map2:
       call   get_a_byte
       jc   bad_gif_in3
       call   get_a_byte
       jc   bad_gif_in3
       call   get_a_byte
       jc   bad_gif_in3
       loop   get_rest_map2
;      jmp   no_desc_map
no_desc_map:
;
; set up initial values
; codesize is the very first byte of each line
       call  reset_segs
       call get_a_byte
       mov  ah,0
       mov  codesize,ax
; calc constants needed
; next get the first block count
       call  get_a_byte
       mov   ah,0
       inc   ax
       mov   code_count,ax
; prime the pump
       mov  save_si,si
       mov  save_bp,bp
       call  get_a_bytec
       mov   cur_byte,al
       call  get_a_bytec
       mov   cur_byte+1,al
       call  get_a_bytec
       mov   extra_byte,al
       mov  cur_bits,24
;
; continue now
       mov   di,0
       mov   save_di,di
       mov   save_si,si
       mov   save_bp,bp
       clc
       ret
bad_gif_in3:
   jmp  bad_gif_in
get_color_map:
       lea   di,color_map
       cld
pcc_cloop:
       push  cx
       mov    bl,0
; red first
       call   get_col
       jc      bad_col_in
       mov    cx,ax
       and    cx,1
       shl    cx,1
       shl    cx,1
       add    bl,cl
       shr    ax,1
       mov    cl,5
       shl    ax,cl
       add    bl,al
; green
       call   get_col
       jc      bad_col_in
       mov    cx,ax
       and    cx,1
       shl    cx,1
       add    bl,cl
       shr    ax,1
       mov    cl,4
       shl    ax,cl
       add    bl,al
; blue
       call   get_col
       jc      bad_col_in
       mov    cx,ax
       and    cx,1
       add    bl,cl
       shr    ax,1
       mov    cl,3
       shl    ax,cl
       add    bl,al
       mov     al,bl
       stosb
       pop   cx
       loop pcc_cloop
      push  si
      push  bp
       lea   dx,color_map
       mov   ah,10h  ; set pallette
       mov   al,2
       int   10h
       pop   bp
       pop   si
       clc
       ret
bad_col_in:
       stc
       ret
get_col:
       call get_a_byte
       jc   bad_gif_inc
       mov    ah,0
       mov    cl,6
       shr    ax,cl
       cmp    ax,0
       je     done_col
       cmp    ax,3
       je     done_col
       cmp    al,1
       je     col1
       mov    al,0
col1:
       inc    ax
done_col:
       ret

; now we loop through the three colors per map
bad_gif_inc:
      stc
      ret
GIF_IN    ENDP
;
;
PRT_IN       PROC    NEAR
public prt_in
;
; this reads  HP LaserJet files and puts them in the workspace
; the header reads until it finds escape t *
     call reset_segs
       mov    ax,vwid
       mov     width_bytes,ax
       shl     ax,1
       shl     ax,1
       shl     ax,1
       MOV     WIDTH_pix,AX
       MOV     HEIGHT_PIX,4000  ;big picture
      push    ds
      push    es
      mov     ax,buffer
      mov     dx,4000h
      mov     es,ax
      mov     ds,ax
      mov     cx,3fffh
      call    read_file
      cmp     ax,0
      pop     es
      pop     ds
      jg      good_prt_read
bad_prt_in:
      stc
      ret
good_prt_read:
      mov     si,4000h
      mov     bp,ax   ; amount in buffer
      add     bp,4000h ; place in buffer
       mov     di,0
       mov   save_di,di
       mov   save_si,si
       mov   save_bp,bp
;
       clc
       ret
;
PRT_IN       ENDP
;
PRT_READ  PROC NEAR
public prt_read
       call  reset_segs
       mov   di,save_di
       mov   si,save_si
       mov   bp,save_bp
top_prt:
; here we get end
       call   get_a_byte
       jc     end_prt_read
       cmp    al,1bh
       jne    top_prt
       call   get_a_byte
       jc     end_prt_read
       cmp    al,'*'
       jne    top_prt
       call   get_a_byte
       jc     end_prt_read
       cmp    al,'b'
       jne    top_prt
       call   get_DEC
       jc     end_prt_read
       cmp   al,'W'
       jne    top_prt
       cmp   dx,0
       jle   end_prt_read
; got a line of stuff
; dx has the decimal amount
       mov   cx,dx
prt_rloop:
       push  dx
       push   cx
       call   get_a_byte
       pop    cx
       pop   dx
       jc     end_prt_read
       xor   al,0ffh
       push   es
       mov   es,buffer
       stosb
       pop  es
       loop    prt_rloop
       mov   cx,width_bytes
       sub   cx,dx
       cmp   cx,0
       jle   ret_prt
       mov   al,0ffh
       cld
       push   es
       mov   es,buffer
rep    stosb
       pop  es
ret_prt:
        mov   cx,width_bytes
        push  si
        push  bp
        mov   si,0
      mov  di,0
      call  flush_buffer
        pop   bp
        pop   si
        jc    end_prt_read
        mov   di,0
       jmp    top_prt
end_prt_read:
      stc
      ret
;
PRT_READ  ENDP
;
;
;
;
SFP_IN       PROC    NEAR
     call reset_segs
      cmp   sfp_header.sfp_esc,1bh
      je    sfp1
bad_sfp:
      stc
      ret
sfp1:
       cmp   sfp_header.sfp_esc+1,')'
       jne   bad_sfp
       cmp   sfp_header.sfp_esc+2,'s'
       jne   bad_sfp
; read the buffer
      push    ds
      push    es
      mov     ax,buffer
      mov     dx,4000h
      mov     es,ax
      mov     ds,ax
      mov     cx,3fffh
      call    read_file
      cmp     ax,0
      pop     es
      pop     ds
      jg      good_sfp_read
      stc
      ret
good_sfp_read:
      mov     si,4000h
      mov     di,0
      mov     bp,ax   ; amount in buffer
      add     bp,4000h ; place in buffer
;
; get the header info
     call   get_dec    ; gets a decimal value
     jc     bad_sfp
     cmp    al,'W'
     jne    bad_sfp
got_fontd:
; have the font descriptor header now have to put the next
; 26 bytes in the font descriptor area
; the font length data comes in dx from get_dec
;
     mov   cx,13
     sub   dx,26
     lea   di,font_descriptor
get_descr_loop:
     push   cx
     call   get_word
     jc     bad_sfp
     xchg   al,ah
     stosw
     pop    cx
     loop   get_descr_loop
     mov    cx,dx
     cmp    cx,0
     jle    no_more_desc
gd_loop2:
     call   get_a_byte
     loop   gd_loop2
no_more_desc:
      mov  ax,cellhght
     cmp    ax,0
     jle    bad_sfp
     mov    font1h,ax
; have read the header,
; get the length
       mov  ax,cellwidth  ; character cell width
       MOV     WIDTH_pix,AX
       add  ax,7
       shr  ax,1
       shr  ax,1
       shr  ax,1
       inc   ax
       MOV     WIDTH_bytes,ax
       mov    width_byteso,ax
       mov  ax,cellhght   ; character cell height
; this now becomes the height of fonts
       MOV     HEIGHT_PIX,AX       ;SAVE AS PIXELS
; now find what letter is wanted
;
      mov     di,0
       mov   save_di,di
       mov   save_si,si
       mov   startsi,si
       mov   save_bp,bp
       mov   buffer_read,0
;
       clc
       ret
bad_sfp2:
       stc
       ret
;
SFP_IN       endp
;
SFP_READ  proc near
public sfp_read
       call  reset_segs
       mov  xor_read,1
       call  present
       call  reset_segs
       call  do_sfpt
       call  reset_segs
       mov  xor_read,0
       stc
       ret
real_sfp:
public real_sfp
       call  reset_segs
       mov   sfp_letter,al
       cmp   al,20h
       jne   not_a_space
       mov   ax,pitch
       shr   ax,1
       shr   ax,1
       add   fx,ax
       mov   last_pitch,ax
       stc
       ret
not_a_space:
; got a buffer full of stuff
       cmp   al,08
       jne   not_backspace
       mov   ax,last_pitch
       sub   fx,ax
       stc
       ret
not_backspace:
       mov   di,0
       mov   si,startsi
       mov   bp,save_bp
       cmp   buffer_read,0
       je    top_fonts
       mov   buffer_read,0
       mov   ax,4200h
       mov   bx,handle
       mov   cx,0
       mov  dx,3
       int   21h
      mov     ax,buffer
      mov     dx,4000h
      mov     es,ax
      mov     ds,ax
      mov     cx,3fffh
      call    read_file
       call  reset_segs

      cmp     ax,0
      jg      good_sfp_read2
      stc
      ret
good_sfp_read2:
      mov     di,0
      mov     bp,ax   ; amount in buffer
      add     bp,4000h ; place in buffer
      mov   si,startsi
    mov  buffer_read,0
top_fonts:
       call  reset_segs
; here we get next character
     call   get_a_byte
     jc     end_fonts1
     cmp    al,1bh
     jne    end_fonts1
     call   get_a_byte
     jc     end_fonts1
     cmp    al,'*'
     jne    end_fonts1
     call   get_a_byte
     jc     end_fonts1
     cmp    al,'c'
     jne    bad_font2
     call   get_dec
     jc     bad_font2
     cmp    al,'E'
     jne    bad_font2
     jmp    got_font2
end_fonts1:
;
bad_font2:
; this message comes up when we are reading the second headers
     stc
     ret
get_word:
       push bx
       call get_a_byte
       jc  gwb
       mov  bl,al
       call get_a_byte
       jc  gwb
       mov  ah,al
       mov  al,bl
       pop  bx
       clc
       ret
gwb:
       pop  bx
       stc
       ret
got_font2:
; returns with dx having the number
       mov  letter,dx
; have the letter number now its time for the letter data
     call   get_word
     jc     bad_font3
     cmp    al,1bh
     jne    bad_font3
     cmp    ah,'('
     jne    bad_font3
     call   get_a_byte
     jc     bad_font3
     cmp    al,'s'
     jne    bad_font3
     call   get_dec
     cmp    al,'W'
     jne    bad_font3
;
     jmp    got_font3
bad_font3:
     stc
     ret
got_font3:
; returns with dx having the number
; the number in dx is the length of the area to read
      mov     fontsize,dx
       mov   ax,letter
       cmp   al,sfp_letter
       je   got_letter
       jmp no_gots_letter
got_letter:
; now we have to get the 16 bytes of good stuff
     mov    cx,8
     lea    di,dchar
head_loop:
     call   get_word
     jc     bad_font4
; have something in ax
     xchg  al,ah
     stosw
     loop    head_loop
       mov   dx,0
       mov   ax,tx
       add   ax,left_off
       cmp   ax,0
       jg    no_left_marg
       mov   ax,0
no_left_marg:
       mov   cx,8  ; bits per byte
       div   cx
       mov   off_bits,dx ; how much to shift to right
       mov   scol,ax
     mov   cx,char_hght
     mov   fontlen,cx
     mov   ax,fontsize
     sub   ax,16
     shl   ax,1
     shl   ax,1
     shl   ax,1   ; mul by 8
     mov   dx,0
     div   cx     ; divide by the length (height)
     mov   fontwidth,ax
        add   ax,7
        shr   ax,1
        shr   ax,1
        shr   ax,1
       inc    ax
       MOV     WIDTH_bytes,ax
       add   ax,scol
       mov   rcol,ax
;
       mov   ax,ty
       mov   srow,ax
       add   ax,height_pix
       mov   rrow,ax
;
       mov   ax,delta_x
       shr   ax,1
       shr   ax,1
       add   fx,ax
       mov   last_pitch,ax
;
     mov   ax,top_off
     mov   fontorig,ax
     jmp    good_head
bad_font4:
; prints error 4 when runs out of stuff on 16 bytes after font head
     stc
     ret
good_head:
; now we have to get all the bytes of the font an normalize them
; into a byte boundary and put them in es:0
        mov    ax,height_pix
        mul    width_bytes
        mov    cx,ax
        push   es
        mov    es,buffer
        mov    di,0
        mov    al,0
rep    stosb
        pop    es
        mov    ax,baseline
        sub    ax,top_off
        mul    width_bytes
        mov    di,ax
        call   get_a_byte ; prime the pump
        mov    bh,8   ; number of bits in al
        mov    bl,0   ; bl has the number of bytes shifted
        mov    cx,fontlen
        mov    dx,fontwidth ; dl has the width of the font
;
; font loop, pass this cx times, dl has the width in bits
        push   es
        mov    es,buffer
font_getl:
        push    cx
        push    dx
        cmp     dl,8  ; even byte per character
        jne     not_8
;
        push  ax
        push  cx
        mov    ah,0
        mov    cx,off_bits
        xchg   al,ah
        shr    ax,cl
        xchg   al,ah
        xor    word ptr es:[di],ax
        inc    di
        pop    cx
        pop    ax
;
        cmp    cx,1
        je     end_font_getl
        call   get_a_byte
        jc     bad_font5
        jmp    end_font_getl
bad_font5:
     pop   dx
     pop   cx
     pop   es
     stc
     ret
not_8:
;  what goes here?
lt_loop:
; check and see if we are done
        cmp   dl,0
        je    lt_done
; check and see if we need a refill in al
        cmp   bh,0
        jg    lt_not_0
        call  get_a_byte
        jc     bad_font5
        mov   bh,8
lt_not_0:
; check and see if we have to dump ah
        cmp   bl,8
        jl    lt_more_shift
        push  ax
        push  cx
        mov   al,0
        mov    cx,off_bits
        shr    ax,cl
        xchg   al,ah
        xor    word ptr es:[di],ax
        pop   cx
        pop   ax
        inc   di
        mov   bl,0
;       jmp   lt_more_shift
lt_more_shift:
; have to shift the guy over until bl=bh
        shl    ax,1
        inc    bl  ; count of bits in ah
        dec    bh  ; count of bits remaining in al
        dec    dl  ; count remaining
        jmp    lt_loop
lt_done:
; ah has something to dump, dl is zero but bl has something in it
; shift ah to the left
        mov   cl,8
        sub   cl,bl
        push  ax
        shl   ah,cl
        push  cx
        mov   al,0
        mov    cx,off_bits
        shr    ax,cl
        xchg   al,ah
        xor    word ptr es:[di],ax
        pop   cx
        pop   ax
        inc   di
        mov   bl,0
        jmp    end_font_getl
font_getl1:
        jmp    font_getl
;
end_font_getl:
        inc   di
        pop    dx
        pop    cx
        loop   font_getl1
        pop    es
; done with this character
        push  bp
        mov   cx,di
        push  cx
        call  cc_setup
        pop   cx
      mov  si,0
      mov  di,0
      call  flush_buffer
      mov  si,0
      mov  di,0
       pop    bp
       mov   save_di,di
       mov   save_si,si
       mov   save_bp,bp
        stc
        ret
no_gots_letter:
; no et on letter , dx has the number of bytes
; must pass through the letter data
;
;
     mov   cx,dx
pass_let:
     push  cx
     call  get_a_byte
     jc   done_pass
     pop   cx
     loop  pass_let
     jmp   top_fonts
done_pass:
     pop   cx
     stc
     ret
;
SFP_READ  endp
;
get_dec:
; this gets decimal bytes until it gets somebody other than a
; number. It puts the value it gets in dx and puts the last byte
; in al.
     push   bx
     mov    bx,0
     mov    dx,0
; got the excape sequence, get the first digit
     call   get_a_byte
     jc     bad_dec
     cmp    al,'0'
     jl     bad_dec
     cmp    al,'9'
     jg     bad_dec
     and    al,0fh
     mov    bl,al
; got a first digit, get next
     call   get_a_byte
     jc     bad_dec
     cmp    al,'0'
     jl     got_dec
     cmp    al,'9'
     jg     got_dec
     and    al,0fh
     mov    bh,bl
     mov    bl,al
; get third
     call   get_a_byte
     jc     bad_dec
     cmp    al,'0'
     jl     got_dec
     cmp    al,'9'
     jg     got_dec
     and    al,0fh
     mov    dl,bh
     mov    bh,bl
     mov    bl,al
; get the last byte.
     call   get_a_byte
     jc     bad_dec
     cmp    al,'0'
     jl     got_dec
     cmp    al,'9'
     jg     got_dec
     and    al,0fh
     mov    dh,dl
     mov    dl,bh
     mov    bh,bl
     mov    bl,al
; get the last byte.
     call   get_a_byte
     jc     bad_dec
got_dec:
; dx:bx has the decimal stuff, al has a non decimal guy
     push   ax
     push   bp
     call   dec2bin
     pop    bp
     pop    ax
     pop    bx
     clc
     ret
bad_dec:
     pop   bx
     stc
     ret
dec2bin:
; converts the 4 digit decimal in dh:dl:bh:bl to bin
     mov     cx,1000
     mov     al,dh
     mov     ah,0
     push    dx
     mul     cx
     mov     bp,ax
     pop     dx
     mov     cl,100
     mov     al,dl
     mul     cl
     mov     dx,ax
     add     dx,bp
     mov     cl,10
     mov     al,bh
     mul     cl
     add     dx,ax
     mov     bh,0
     add     dx,bx
      ret
get_a_byte:
; reads a byte for guys who used it in fp
;
    push  bx
    push  cx
    push  dx
    push  di
    push  ds
    push  es
    call  reset_segs
    cmp   si,bp
    jl    ok_gb
    mov  buffer_read,1
    push  ds
    mov   ds,buffer
    mov     dx,4000h
    mov     cx,3fffh
    call    read_file
    pop     ds
    mov     bp,ax
    add     bp,4000h
    mov     si,4000h
    cmp     ax,0
    jne     ok_gb
    pop  es
    pop  ds
    pop  di
    pop  dx
    pop  cx
    pop  bx
    stc
    ret
ok_gb:
    mov   ds,buffer
    cld
    lodsb
    pop  es
    pop  ds
    pop  di
    pop  dx
    pop  cx
    pop  bx
    clc
    ret
cseg    ENDS
        END
