west = 0   ; 1 = west coast, 0 = east
eval = 0   ; 1 = evaluation copy prints
; OKLOGO displays the OPTIKS LOGO on the screen
print macro string
      lea   dx,string
      call  prbox
      endm
buffersize  EQU   4000h
lseg     SEGMENT PARA PUBLIC 'DATA'
extrn   logo:byte
extrn   font0:byte,font1:byte
lseg     ENDS
dseg     SEGMENT PUBLIC 'DATA'
     ASSUME CS:cseg,DS:dseg,ES:dseg
;
EXTRN  buffer:WORD,width_bytes:WORD,height_pix:word
extrn  curx:word,cury:word,left_margin:word,font:word
extrn  srow:word,lrow:word,scol:word,lcol:word,mode:byte
extrn  vid_wid:word,linkdate:byte,planes:word
extrn  egavga:byte
extrn  msp_headero:word,color_map:byte
extrn  brandname:byte,brand:word,attribute:byte
extrn  splane:byte
;
;  =186  =187  =188  =200  =201  =205
;
if eval
extrn lscale:word
emess  db  0
endif
line1  db  "OPTIKS (R) Copyright 1993 by Keith P. Graham",10
pub    db  "    Registered to Raymond Leon Lambert",10
lk1    db  "Ver. 3.01 Linked: "
linkfill db 27 dup(20h)
       db  10
       db  "For the latest version of OPTIKS call the",10
       db  "Keith Graham Support BBS at (914) 623-0039",0
       db  "For Information about OPTIKS call (914) 623-4161",10
       db  "or the Keith Graham Support BBS at (914) 623-0039"
       db  0
serialn db  "00000 "
usern  db  8  dup (20h)
       db  0
; the default file is the file where the default is stored
default_file DB   'CONFIG.OK',0 ; name of config file
;
scolor   db  0,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1,0

;

public thanks
thanks      DB    13,10,'Thank you for using OPTIKS',13,10
            DB    'Copyright 1993 by Keith P. Graham',13,10
       db  "Please register this software with:",13,10
       db  "Keith P. Graham",13,10
       db  "238 Germonds Road",13,10
       db  "West Nyack, NY 10994",13,10
       db  "For the latest version of OPTIKS call the",13,10
       db  "Keith Graham Support BBS at (914) 623-0039",0,"$"
public shareware
shareware db "      THIS PROGRAM IS NOT FREE!!!!!!!!",10
          db "This is a copyright program that Keith Graham",10
          db "has been working on for 5 years. Continued",10
          db "use of this program requires registration.",10
          db "Purchase of this program from a disk copying",10
          db "service or shareware vendor does not count as",10
          db "registration. Registration costs only $35.00",10
          db "Corporate site license is only $98.00.",10
          db "Without user registrations, there will be no",10
          db "more good shareware. Please don't cheat.",10
          db "  IF YOU USE THIS PROGRAM, REGISTER IT!",10,10
          db "   press a key after tone to continue",0
testb       db  '1'
dseg     ENDS
cseg     SEGMENT PUBLIC 'CODE'
     ASSUME CS:cseg,DS:dseg,ES:dseg
EXTRN     reset_segs:NEAR,prbox:near
extrn     flush_buffer:near,present:near,erase_rmem:near
extrn     printline:near,do_col_char:near
public     do_logo,say_hello
;
;
;
do_logo:
     call  reset_segs
jmp move_link
; move the serial number
     mov   ax,brand
     mov   cx,10000
     mov   dx,0
     div   cx
     or    al,30h
     mov   serialn,al
     mov   ax,dx
     mov   dx,0
     mov   cx,100
     div   cx
     mov   cl,10
     div   cl
     or    ax,3030h
     mov word ptr serialn+1,ax
     mov   ax,dx
     div   cl
     or    ax,3030h
     mov word ptr serialn+3,ax
     lea   si,brandname
     lea   di,usern
     mov   cx,40
     cld
rep  movsb      ; moves in the use id
; move the link date
move_link:
     lea  si,linkdate
     lea  di,linkfill
     mov  cx,26
     cld
rep   movsb
     push  es
     MOV     WIDTH_BYTES,79
;    MOV     HEIGHT_PIX,94
     MOV     HEIGHT_PIX,132
     mov     srow,28
     mov     scol,2
     mov     lrow,160
     mov     lcol,90
     cmp     vid_wid,80
     je     ok_vid_wid
     mov     scol,6
ok_vid_wid:
     cmp   egavga,1
     je    is_planes
     cmp   mode,-1
     je    is_planes
     cmp   mode,10h
     jl    no_planesx
     cmp   mode,12h
     jg    no_planesx
is_planes:
     jmp   re_enter
no_planesx:
     jmp   no_planes
re_enter:
     call present
     MOV     WIDTH_BYTES,79
;    MOV     HEIGHT_PIX,94*4
     MOV     HEIGHT_PIX,103*4
     mov     srow,28*4
     mov     scol,2
     mov     lrow,144*4
     mov     lcol,90
     mov   ax,buffer
     mov   es,ax
     push  ds
     mov   ax,lseg
     mov   ds,ax
     assume ds:lseg
     lea   si,logo
     assume ds:dseg
     mov   di,0
     cld
; logo is 79 by 94
;    mov   cx,94  ; number of lines
     mov   cx,103   ; number of lines
     cld
clogo0:
     push  cx
     push  si
     mov   cx,79  ; number of bytes to move first
     add   si,79
rep  movsb
     pop   si
     mov   cx,2   ; number of planes we are doing
clogo2:
     push  si
     push  cx
     mov   cx,79
rep     movsb
     pop   cx
     pop   si
     loop  clogo2
     push  si
     mov   cx,79  ; number of bytes to move first
clogo1:
     lodsb
     xor   al,0ffh
     stosb
     loop  clogo1
     pop   si
     add   si,79
     pop   cx
     loop  clogo0
;
;
     pop   ds
     pop   es
     mov   cx,di
     mov   si,0
     mov   di,0
     call  flush_buffer
     call reset_segs
     mov   ax,planes
     push  ax
     mov   planes,4
     call present
     call reset_segs
     pop   ax
     mov   planes,ax
     call  by_enter
     jmp   after_hello
no_planes:
; first thing is to fill the buffer with the logo
     mov   ax,buffer
     mov   es,ax
     push  ds
     mov   ax,lseg
     mov   ds,ax
     assume ds:lseg
     lea   si,logo
     assume ds:dseg
     mov   di,0
     cld
     mov   cx,2400h
rep     movsb
     mov   ax,0
     stosw
     pop   ds
     pop   es
     mov   cx,2400h
     call  flush_buffer
     call say_hello
after_hello:
     call erase_rmem
; now erase the logo area for use as a font (or whatever)
     mov   ax,lseg
     mov   es,ax
     lea   di,logo
     mov   cx,132*79
     mov   al,0
;ep   stosb
     call reset_segs
     RET
say_hello:
     call reset_segs
     call present
     call reset_segs
by_enter:
     assume ds:lseg
     lea  ax,font1
     assume ds:dseg
     cmp  mode,6
     jle  lil_font
     assume ds:lseg
     lea  ax,font0
     assume ds:dseg
lil_font:
     mov  font,ax
     mov  splane,6
     mov  curx,128
     mov  cury,136
     mov  left_margin,128
     print line1
     ret
; testing purposes
     mov  splane,1
     mov  curx,0
     mov  cury,300
     mov  cx,15
testb_loop:
     push cx
     mov  si,offset testb
     mov  cx,1
     call printline
     inc   splane
     inc   testb
     add   curx,16
     cmp   testb,3ah
     jne   testb_by
     mov   testb,'A'
testb_by:
     pop  cx
     loop  testb_loop

     mov  splane,1
     mov  curx,0
     mov  cury,320
     mov  cx,15
testb2_loop:
     push cx
     mov  al,testb
     call do_col_char
     inc   splane
     inc   testb
     add   curx,16
     cmp   testb,3ah
     jne   testb2_by
     mov   testb,'A'
testb2_by:
     pop  cx
     loop  testb2_loop

     ret

cseg     ENDS
     END
